//stylesheets
interface StyleSheet {
	const type:String;
	var disabled:Boolean;
	const ownerNode:Node;
	const parentStyleSheet:StyleSheet;
	const href:String;
	const title:String;
	const media:MediaList;
}

interface StyleSheetList {
	const length:Number;
	function item(index:Number):StyleSheet;
}

interface MediaList {
	var mediaText:String;
	const length:Number;
	function item(index:Number):String;
	throws(DOMException) function deleteMedium(oldMedium:String):void;
	throws(DOMException) function appendMedium(newMedium:String):void;
}

interface LinkStyle {
	const sheet:StyleSheet;
}

interface DocumentStyle {
	const styleSheets:StyleSheetList;
}

